=== src/gnuwin32/xdr/Makefile ===
include ../MkRules

CFLAGS=-O2 -I. -DWIN32

../xdr.a: xdr.o xdr_float.o xdr_stdio.o

clean:
	$(RM) *.o *~
